//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Winbourne.dll;

using System;
using System.Diagnostics;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Generators.PickListController;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.TrendTex.Generators.BarcodeController;
using Produmex.Sbo.Logex.TrendTex.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.TrendTex.Extensions.Interfacing;
using Produmex.Sbo.Logex.TrendTex.Generators.PickListRobot;

namespace AddUpdateScript
{
	class Program
	{
		static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US;ExtraDb=PMX_SBODemo_US;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2014;DBCultureInfo=en-US;LicenseServer=localhost:30000";

		/// <summary>
		/// Used for logging
		/// </summary>
		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		static void Main(string[] args)
		{
			try
			{
				Produmex.Foundation.Diagnostics.LogProvider.SetConsoleAppender("WARN");
				Execute();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
			}
			if (Debugger.IsAttached)
			{
				Console.WriteLine("Press <Enter>");
				Console.ReadLine();
			}
		}

		//private static readonly Assembly s_trendTexAssembly = typeof(Produmex.Sbo.Logex.TrendTex.SboCommands).Assembly;
		//private static string LOCATION_SCRIPTS = "Produmex.Sbo.Logex.TrendTex.Scripts.";

		static void Execute()
		{

			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (PmxDbConnectionSql conn = new PmxDbConnectionSql(CONNECTION_STRING))
				{
					conn.Open(); //Open connection to SAP
					Console.WriteLine("Connection is open to database");

					Console.WriteLine("Extensions");


                   

                    AddUpdateExtension(
					TrendTexBarcodeController.IDs.ExtCode,
					"TrendTex barcode controller - Extension for item quantity",
					typeof(TrendTexBarcodeController),
					Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IBARCODECONTROLLER,
					conn
					);

					AddUpdateExtension(
					PickListRobot.IDs.ExtCode,
					"Pick list robot controller - Extension for pick list robot",
					typeof(PickListRobot),
					Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IPICKLISTROBOT,
					conn
					);

					AddUpdateExtensionParameter(
						PickListRobot.IDs.ExtParamOpenSalesOrderLinesViewName,
						"View name for open sales order lines",
						PickListRobot.IDs.ExtCode,
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						"PMX_TT_OPEN_SALES_ORDER_LINES",
						null,
						conn);

					AddUpdateExtensionParameter(
						PickListRobot.IDs.ExtParamOpenSalesOrderLinesOrderBy,
						"Order by clause for the open sales order lines view",
						PickListRobot.IDs.ExtCode,
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						"DocEntry, DocLineShipDate, ItemCode",
						null,
						conn);

					AddUpdateExtensionParameter(
						PickListRobot.IDs.ExtParamSalesOrderLinesToClose,
						"View name for sales order lines to be closed",
						PickListRobot.IDs.ExtCode,
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						"PMX_TT_SALES_ORDER_LINES_TO_CLOSE",
						null,
						conn);

					AddUpdateExtensionParameter(
						PickListRobot.IDs.ExtParamMovePartialQuantity,
						"View name for moving partial quantity to Lost & Found",
						PickListRobot.IDs.ExtCode,
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						"PMX_TT_MOVE_PARTIAL_QUANTITY",
						null,
						conn);

					AddUpdateExtensionParameter(
						PickListRobot.IDs.ExtParamCreatePickLists,
						"View name for creating pick lists",
						PickListRobot.IDs.ExtCode,
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						"PMX_TT_CREATE_PICK_LISTS",
						null,
						conn);

                    AddUpdateExtension(
                    PmxAdvanceShippingNoticeInterfaceTrendTex.IDs.ExtCode,
                    "IPmxAdvanceShippingNoticeInterface - Trend-Tex",
                    typeof(PmxAdvanceShippingNoticeInterfaceTrendTex),
                    Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IADVANCESHIPPINGNOTICE_INTERFACE,
                    conn
                    );

                  


                }

				//Complete transaction
				scope.Complete();
			}



			//PMX connection
			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
				{
					dbConn.Open();

					Console.WriteLine("Tables");
					Console.WriteLine("Views");

					// Views
					Assembly assembly = Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.TrendTex.SboCommands));
					string viewName = Produmex.Sbo.Logex.TrendTex.ViewObjects.Definitions.Views.PmxOpenSalesOrderLinesTT.NAME;
					string resourceName = "Produmex.Sbo.Logex.TrendTex" + ".Scripts.Views." + viewName + ".sql";
					dbConn.DbTool.CreateUpdateView(viewName, PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName), dbConn));

					viewName = Produmex.Sbo.Logex.TrendTex.ViewObjects.Definitions.Views.PmxSalesOrderLinesToCloseTT.NAME;
					resourceName = "Produmex.Sbo.Logex.TrendTex" + ".Scripts.Views." + viewName + ".sql";
					dbConn.DbTool.CreateUpdateView(viewName, PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName), dbConn));

					viewName = Produmex.Sbo.Logex.TrendTex.ViewObjects.Definitions.Views.PmxMovePartialQuantityTT.NAME;
					resourceName = "Produmex.Sbo.Logex.TrendTex" + ".Scripts.Views." + viewName + ".sql";
					dbConn.DbTool.CreateUpdateView(viewName, PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName), dbConn));

					viewName = Produmex.Sbo.Logex.TrendTex.ViewObjects.Definitions.Views.PmxCreatePickListsTT.NAME;
					resourceName = "Produmex.Sbo.Logex.TrendTex" + ".Scripts.Views." + viewName + ".sql";
					dbConn.DbTool.CreateUpdateView(viewName, PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName), dbConn));

					//Complete transaction
					scope.Complete();
				}
			}

			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (SboConnection conn = new SboConnection(CONNECTION_STRING))
				{
					conn.Open(); //Open connection to SAP
					
					// * UDF's *
					Console.WriteLine("UDFs");
					SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);

					SboColumnDefinitionAttribute colDef = new SboColumnDefinitionAttribute(
						PmxBusinessPartnerTableTT.Columns.CREDITAPPV.NAME,
						PmxBusinessPartnerTableTT.Columns.CREDITAPPV.DESCR,
						PmxBusinessPartnerTableTT.Columns.CREDITAPPV.TYPE,
						PmxBusinessPartnerTableTT.Columns.CREDITAPPV.SIZE,
						PmxBusinessPartnerTableTT.Columns.CREDITAPPV.SUB_TYPE);
					colDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					colDef.DefaultValue = SboBooleanColumnValues.N.VALUE;
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTableTT.NAME, colDef);

					colDef = new SboColumnDefinitionAttribute(
						PmxBusinessPartnerTableTT.Columns.ShipFrequency.NAME,
						PmxBusinessPartnerTableTT.Columns.ShipFrequency.DESCR,
						PmxBusinessPartnerTableTT.Columns.ShipFrequency.TYPE,
						PmxBusinessPartnerTableTT.Columns.ShipFrequency.SIZE,
						PmxBusinessPartnerTableTT.Columns.ShipFrequency.SUB_TYPE);
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTableTT.NAME, colDef);

					colDef = new SboColumnDefinitionAttribute(
						PmxBusinessPartnerTableTT.Columns.Complete.NAME,
						PmxBusinessPartnerTableTT.Columns.Complete.DESCR,
						PmxBusinessPartnerTableTT.Columns.Complete.TYPE,
						PmxBusinessPartnerTableTT.Columns.Complete.SIZE,
						PmxBusinessPartnerTableTT.Columns.Complete.SUB_TYPE);
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTableTT.NAME, colDef);

					colDef = new SboColumnDefinitionAttribute(
						PmxBusinessPartnerTableTT.Columns.AsPossible.NAME,
						PmxBusinessPartnerTableTT.Columns.AsPossible.DESCR,
						PmxBusinessPartnerTableTT.Columns.AsPossible.TYPE,
						PmxBusinessPartnerTableTT.Columns.AsPossible.SIZE,
						PmxBusinessPartnerTableTT.Columns.AsPossible.SUB_TYPE);
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTableTT.NAME, colDef);

					colDef = new SboColumnDefinitionAttribute(
						PmxBusinessPartnerTableTT.Columns.NotReqd.NAME,
						PmxBusinessPartnerTableTT.Columns.NotReqd.DESCR,
						PmxBusinessPartnerTableTT.Columns.NotReqd.TYPE,
						PmxBusinessPartnerTableTT.Columns.NotReqd.SIZE,
						PmxBusinessPartnerTableTT.Columns.NotReqd.SUB_TYPE);
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTableTT.NAME, colDef);

					colDef = new SboColumnDefinitionAttribute(
						PmxBusinessPartnerTableTT.Columns.BOMin.NAME,
						PmxBusinessPartnerTableTT.Columns.BOMin.DESCR,
						PmxBusinessPartnerTableTT.Columns.BOMin.TYPE,
						PmxBusinessPartnerTableTT.Columns.BOMin.SIZE,
						PmxBusinessPartnerTableTT.Columns.BOMin.SUB_TYPE);
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTableTT.NAME, colDef);

					colDef = new SboColumnDefinitionAttribute(
						PmxSalesOrderTableTT.Columns.Completion.NAME,
						PmxSalesOrderTableTT.Columns.Completion.DESCR,
						PmxSalesOrderTableTT.Columns.Completion.TYPE,
						PmxSalesOrderTableTT.Columns.Completion.SIZE,
						PmxSalesOrderTableTT.Columns.Completion.SUB_TYPE);
					udfProv.AddUpdateUserfield(PmxSalesOrderTableTT.NAME, colDef);

                    PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);
                    updateProv.AddUpdateProperty(Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IADVANCESHIPPINGNOTICE_INTERFACE, "Interface for PMX Advance Shipping Notice im-/exporter",
                  Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IADVANCESHIPPINGNOTICE_INTERFACE,
                  Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.DEFAULT_ADVANCE_SHIPPING_NOTICE_INTERFACE);



                    //Complete transaction
                    scope.Complete();
				}
			}

			Console.WriteLine("Done ...");
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtension"/>
		/// </summary>
		/// <param name="code">The code of the extension.</param>
		/// <param name="name">The name of the extension.</param>
		/// <param name="type">The type of the extension.</param>
		/// <param name="extensionTypeCode">The extension type code.</param>
		/// <param name="conn">The SBO connection</param>
		private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnectionSql conn)
		{
			PmxExtensionProvider prov = new PmxExtensionProvider(conn);
			PmxExtension extension = null;
			try
			{
				bool newBO = false;
				extension = prov.GetBO(code);
				if (extension == null)
				{
					newBO = true;
					extension = prov.GetNewBO();
					extension.Code = code;
				}
				extension.Name = name;
				extension.ExtensionTypeCode = extensionTypeCode;
				extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
				if (newBO)
				{
					prov.AddBO(extension);
				}
				else
				{
					prov.UpdateBO(extension, false, false);
				}
			}
			finally
			{
				if (extension != null) extension.Dispose();
			}
		}




		/// <summary>
		/// Add/Update script workflow
		/// </summary>
		/// <param name="executionType">Type of the execution.</param>
		/// <param name="name">The name of the flow.</param>
		/// <param name="sourceFilePath">Name of the file.</param>
		/// <param name="sqlConn">The SQL conn.</param>
		private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
		{
			PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
			PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
			PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
			PmxWorkflowScript bo = null;
			if (workflow == null)
			{
				//add the workflow
				bo = wfscProvider.GetNewBO();
				bo.Name = name;
				wfscProvider.AddBO(bo);
			}
			else
			{
				if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
				{
					bo = wfscProvider.GetBO(workflow.InternalKey);

				}
			}

			if (bo != null)
			{
				bo.ExecutionType = executionType;

				wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
			}



		}

		/// <summary>
		/// Runs the table SQL script.
		/// </summary>
		/// <param name="tableScript">The table script.</param>
		/// <param name="conn">The conn.</param>
		private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
		{
			string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.TrendTex.SboCommands)), "Produmex.Sbo.Logex.TrendTex.Scripts.Tables." + tableScript);
			SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}

		/// <summary>
		/// Adds the update user fields not in transaction.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="types">The types.</param>
		private static void AddUpdateUserFieldsNotInTransaction(SboConnection conn, params Type[] types)
		{
			SboUserFieldMDProvider userFieldMDProv = new SboUserFieldMDProvider(conn);
			//System.Data.Common.DbTransaction transaction = null;
			try
			{
				//transaction = this.Connection.BeginTransaction();
				userFieldMDProv.AddUpdateUserFields(types);

				//Commit transaction
				//transaction.Commit();
			}
			catch (Exception)
			{
				//if (transaction != null) transaction.Rollback();
				throw;
			}
		}

		/// <summary>
		/// Runs the stored procedure SQL script.
		/// </summary>
		/// <param name="spScript">The sp script.</param>
		/// <param name="conn">The conn.</param>
		private static void RunStoredProcedureSqlScript(string spScript, PmxDbConnection conn)
		{
			string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.TrendTex.SboCommands)), "Produmex.Sbo.Logex.TrendTex.Scripts.StoredProcedures." + spScript);
			SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtensionParameter" />
		/// </summary>
		/// <param name="code">The code of the extension parameter.</param>
		/// <param name="name">The name of the extension parameter.</param>
		/// <param name="extensionCode">The extension code.</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="defaultValue">The default value.</param>
		/// <param name="grouping">The grouping parameter.</param>
		/// <param name="conn">The connection parameter</param>
		private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string grouping, PmxDbConnection conn)
		{
			AddUpdateExtensionParameter(code, name, extensionCode, convertorCode, defaultValue, code, grouping, conn);
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtensionParameter" />
		/// </summary>
		/// <param name="code">The code of the extension parameter.</param>
		/// <param name="name">The name of the extension parameter.</param>
		/// <param name="extensionCode">The extension code.</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="defaultValue">The default value.</param>
		/// <param name="generalParameterCode">The general parameter code.</param>
		/// <param name="grouping">The grouping parameter.</param>
		/// <param name="conn">The connection parameter</param>
		private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, string grouping, PmxDbConnection conn)
		{
			AddUpdateExtensionParameter(code, name, extensionCode, convertorCode, defaultValue, generalParameterCode, 0, grouping, conn);
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtensionParameter" />
		/// </summary>
		/// <param name="code">The code of the extension parameter.</param>
		/// <param name="name">The name of the extension parameter.</param>
		/// <param name="extensionCode">The extension code.</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="defaultValue">The default value.</param>
		/// <param name="generalParameterCode">The general parameter code.</param>
		/// <param name="sequence">The sequence parameter.</param>
		/// <param name="grouping">The grouping parameter.</param>
		/// <param name="conn">The connection parameter</param>
		private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, int sequence, string grouping, PmxDbConnection conn)
		{
			PmxExtensionParameterProvider prov = new PmxExtensionParameterProvider(conn);
			PmxExtensionParameter extParam = null;

			try
			{
				bool newBO = false;
				extParam = prov.GetBO(code);

				if (extParam == null)
				{
					newBO = true;
					extParam = prov.GetNewBO();
					extParam.Code = code;
				}

				extParam.Name = name;
				extParam.ExtensionCode = extensionCode;
				extParam.ConvertorCode = convertorCode;
				extParam.GeneralParameterCode = generalParameterCode;
				extParam.DefaultValue = defaultValue;
				extParam.Sequence = sequence;
				extParam.Grouping = grouping;

				if (newBO)
				{
					prov.AddBO(extParam);
				}
				else
				{
					prov.UpdateBO(extParam, false, false);
				}
			}
			finally
			{
				if (extParam != null)
					extParam.Dispose();
			}
		}

		/// <summary>
		/// Preprocesses the SQL script.
		/// </summary>
		/// <param name="query">The query.</param>
		/// <param name="conn">The connection.</param>
		/// <returns></returns>
		private static string PreprocessSqlScript(string query, PmxDbConnection conn)
		{
			string serverType;
			switch (conn.ConnectionStringObject.ServerType)
			{
				case SboServerType.HANA:
					serverType = "HANA";
					query = query.Replace("{DB-SCHEMA}", "\"" + conn.ConnectionStringObject.CompanyDBSchema.SchemaName + "\"")
								 .Replace("{EXTRA-DB-SCHEMA}", "\"" + conn.ConnectionStringObject.ExtraDBSchema.SchemaName + "\"");
					break;
				default:
					serverType = "MSSQL";
					break;
			}

			int mssqlBlockBegin = query.IndexOf("--<?DB:");
			while (mssqlBlockBegin >= 0)
			{
				int mssqlBlockEnd = query.IndexOf("--?>", mssqlBlockBegin);
				if (mssqlBlockEnd < 0)
				{
					break;
				}

				if (query.Substring(mssqlBlockBegin + "--<?DB:".Length, serverType.Length) == serverType)
				{
					query = query.Substring(0, mssqlBlockBegin)
						  + query.Substring(mssqlBlockBegin + "--<?DB:".Length + serverType.Length, mssqlBlockEnd - mssqlBlockBegin - "--<?DB:".Length - serverType.Length)
						  + query.Substring(mssqlBlockEnd + "--?>".Length);
					mssqlBlockEnd -= "--<?DB:".Length + serverType.Length + "--?>".Length;
				}
				else
				{
					query = query.Substring(0, mssqlBlockBegin) + query.Substring(mssqlBlockEnd + "--?>".Length);
					mssqlBlockEnd = mssqlBlockBegin;
				}
				mssqlBlockBegin = query.IndexOf("--<?DB:", mssqlBlockEnd);
			}

			if (conn.ConnectionStringObject.ServerType == SboServerType.HANA)
			{
				int tokenPos = query.IndexOf("ISNULL(", StringComparison.OrdinalIgnoreCase);
				while (tokenPos >= 0)
				{
					int endPos = tokenPos + "ISNULL(".Length;
					query = query.Substring(0, tokenPos) + "IFNULL(" + query.Substring(endPos);
					tokenPos = query.IndexOf("ISNULL(", endPos, StringComparison.OrdinalIgnoreCase);
				}

				tokenPos = query.IndexOf("@");
				while (tokenPos >= 0)
				{
					if (query[tokenPos - 1] != '"' && Char.IsLetter(query[tokenPos + 1]))
					{
						query = query.Substring(0, tokenPos) + "p_" + query.Substring(tokenPos + 1);
					}
					tokenPos = query.IndexOf("@", tokenPos + 2);
				}
			}

			return query;
		}
	}
}
