USE [TRENDTEX]
GO

/****** Object:  UserDefinedFunction [dbo].[PMX_FN_OpenSalesOrdersEntitlement_V1]    Script Date: 2018-09-12 4:31:21 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



--[RA-]


CREATE FUNCTION [dbo].[PMX_FN_OpenSalesOrdersEntitlement_V1]
(

)
RETURNS @tbl TABLE ( 
"ObjType" nvarchar(50),
"ObjTypeString" nvarchar(100),
"DocEntry" int,
"DocNum" int,
"DocDueDate" date,
"DocLineShipDate" date,
"CardCode" nvarchar(50),
"CardName" nvarchar(100),
"ShipToAddress" nvarchar(100),
"ShipToCode" nvarchar(100),
"ItemCode" nvarchar(50),
"ItemName" nvarchar(100),
"ItmsGrpCod" nvarchar(50),
"LineNum" int,
"WhsCode" nvarchar(10),
"ShippingType" nvarchar(50),
"NumAtCard" nvarchar(50),
"PickRmrk" nvarchar(4000),
"OpenQuantity" decimal(19,6),
"OpenVolume" decimal(19,6),
"OpenWeight" decimal(19,6),
"OpenPrice" decimal(19,6),
"TotalQuantity" decimal(19,6),
"UniqueItems" int,
"TotalVolume" decimal(19,6),
"TotalWeight" decimal(19,6),
"TotalPrice" decimal(19,6),
"Free stock" decimal (19,6),
"UOM" nvarchar(20),
"DraftDocEntry" int,
"Allocation" int,
BoltsOrdered int,

allocationOK NVARCHAR(1), 
freestockRunning NUMERIC(19,6),
CurrentAllocation int,
NumBoltsAllocatable int


) AS
BEGIN


DECLARE  @EntitlementOrders TABLE( 
"ObjType" nvarchar(50),
"ObjTypeString" nvarchar(100),
"DocEntry" int,
"DocNum" int,
"DocDueDate" date,
"DocLineShipDate" date,
"CardCode" nvarchar(50),
"CardName" nvarchar(100),
"ShipToAddress" nvarchar(100),
"ShipToCode" nvarchar(100),
"ItemCode" nvarchar(50),
"ItemName" nvarchar(100),
"ItmsGrpCod" nvarchar(50),
"LineNum" int,
"WhsCode" nvarchar(10),
"ShippingType" nvarchar(50),
"NumAtCard" nvarchar(50),
"PickRmrk" nvarchar(4000),
"OpenQuantity" decimal(19,6),
"OpenVolume" decimal(19,6),
"OpenWeight" decimal(19,6),
"OpenPrice" decimal(19,6),
"TotalQuantity" decimal(19,6),
"UniqueItems" int,
"TotalVolume" decimal(19,6),
"TotalWeight" decimal(19,6),
"TotalPrice" decimal(19,6),
"Free stock" decimal (19,6),
"UOM" nvarchar(20),
"DraftDocEntry" int,
"Allocation" int,
BoltsOrdered int

)




 INSERT @EntitlementOrders
SELECT DISTINCT 
"ORDR"."ObjType" AS "ObjType", 
N'                                                                                                    ' AS "ObjTypeString",
"ORDR"."DocEntry" AS "DocEntry",
"ORDR"."DocNum" AS "DocNum", 
"ORDR"."DocDueDate" AS "DocDueDate", 
"RDR1"."ShipDate" AS "DocLineShipDate", 
"ORDR"."CardCode" AS "CardCode", 
"ORDR"."CardName" AS "CardName", 
"ORDR"."Address2" AS "ShipToAddress", 
"ORDR"."ShipToCode" AS "ShipToCode", 
"RDR1"."ItemCode" AS "ItemCode",
"OITM"."ItemName" AS "ItemName",
"OITM"."ItmsGrpCod" AS "ItmsGrpCod",
"RDR1"."LineNum" AS "LineNum",
"RDR1"."WhsCode" AS "WhsCode",
"OSHP"."TrnspName" AS "ShippingType", 
"ORDR"."NumAtCard" AS "NumAtCard", 
"ORDR"."PickRmrk" AS "PickRmrk", 
"RDR1"."OpenQty" - ISNULL(PMX_DOLL."LockedQuantity", 0) AS "OpenQuantity", 
SUM("PMX_OITM_MEASUREMENTS"."SVolume" * "OLGT"."SizeInMM" * "OLGT"."SizeInMM" * "OLGT"."SizeInMM" * 1E-9 * ("RDR1"."OpenQty" - ISNULL(PMX_DOLL."LockedQuantity", 0))) AS "OpenVolume", 
SUM("PMX_OITM_MEASUREMENTS"."SWeight1" * "OWGT"."WightInMG" * 1E-6 * ("RDR1"."OpenQty" - ISNULL(PMX_DOLL."LockedQuantity", 0))) AS "OpenWeight", 
SUM("RDR1"."LineTotal" * ("RDR1"."OpenQty" - ISNULL(PMX_DOLL."LockedQuantity", 0)) / "RDR1"."Quantity") AS "OpenPrice", 
SUM("RDR1"."Quantity") AS "TotalQuantity", 
COUNT(DISTINCT "RDR1"."ItemCode") AS "UniqueItems", 
SUM("PMX_OITM_MEASUREMENTS"."SVolume" * "OLGT"."SizeInMM" * "OLGT"."SizeInMM" * "OLGT"."SizeInMM" * 1E-9 * "RDR1"."Quantity") AS "TotalVolume", 
SUM("PMX_OITM_MEASUREMENTS"."SWeight1" * "OWGT"."WightInMG" * 1E-6 * "RDR1"."Quantity") AS "TotalWeight"
, SUM("RDR1"."LineTotal") AS "TotalPrice"


 ,(ISNULL((SELECT SUM( "PMX_INVT"."Quantity" ) AS "Quantity" FROM "PMX_INVT" 
 INNER JOIN "PMX_OSEL" ON "PMX_INVT"."StorLocCode" = "PMX_OSEL"."Code" 
 INNER JOIN "PMX_OSWH" ON "PMX_OSWH"."Code" = "PMX_OSEL"."PmxWhsCode"
 INNER JOIN "PMX_QYST" ON "PMX_INVT"."QualityStatusCode" = "PMX_QYST"."Code" 
  WHERE "PMX_INVT"."ItemCode" = "RDR1"."ItemCode" AND "PMX_OSWH"."SboWhsCode" = "RDR1"."WhsCode"
  AND ("PMX_QYST"."CanBeShipped" = 'Y' OR "PMX_QYST"."CanBeShippedUnderQuarantine" = 'Y')
  AND ISNULL("PMX_INVT"."StorLocCode", '')  NOT IN ( SELECT "PMX_DISALLOWED_LOCATIONS_FOR_PICKING"."Code" FROM "PMX_DISALLOWED_LOCATIONS_FOR_PICKING" WHERE "PMX_DISALLOWED_LOCATIONS_FOR_PICKING"."Code" IS NOT NULL  ) 

 GROUP BY "PMX_INVT"."ItemCode"),0)
 -
 ISNULL((SELECT SUM( "PMX_INLD"."Quantity" ) AS "Quantity"
 FROM "PMX_INLD"
 INNER JOIN "PMX_OSWH" ON "PMX_OSWH"."Code" = "PMX_INLD"."PmxWhsCode"
 WHERE "PMX_INLD"."ItemCode" = "RDR1"."ItemCode" AND "PMX_OSWH"."SboWhsCode" = "RDR1"."WhsCode" 
 GROUP BY "PMX_INLD"."ItemCode"),0)) AS "Free stock",
 rdr1.unitMsr as UOM
  ,drf1.DocEntry
  ,OCRDPDMX.U_V33_allocation as Allocation
  ,RDR1.U_NUMBOLT as BoltsOrdered


 FROM "ORDR"
 INNER JOIN "RDR1" ON "RDR1"."DocEntry" = "ORDR"."DocEntry"
 INNER JOIN "OITM" ON "OITM"."ItemCode" = "RDR1"."ItemCode"
 INNER JOIN "OCRD" ON "ORDR"."CardCode" = "OCRD"."CardCode"
 LEFT JOIN "OSHP" ON "ORDR"."TrnspCode" = "OSHP"."TrnspCode"
 LEFT JOIN 
 ( 
	 SELECT "PMX_DOLL"."DocEntry", "PMX_DOLL"."LineNum", "PMX_DOLL"."ObjType", SUM("PMX_DOLL"."LockedQuantity") AS "LockedQuantity"
	 FROM PMX_DOLL
	 GROUP BY "PMX_DOLL"."DocEntry", "PMX_DOLL"."LineNum", "PMX_DOLL"."ObjType"
 ) AS  "PMX_DOLL" ON "PMX_DOLL"."DocEntry" = "RDR1"."DocEntry" AND "PMX_DOLL"."LineNum" = "RDR1"."LineNum" AND "PMX_DOLL"."ObjType" = "ORDR"."ObjType"
 LEFT JOIN "PMX_OITM_MEASUREMENTS" ON "PMX_OITM_MEASUREMENTS"."ItemCode" = "OITM"."ItemCode" AND "RDR1"."UomEntry" = "PMX_OITM_MEASUREMENTS"."UomEntry"
 LEFT JOIN "OLGT" ON "OLGT"."UnitCode" = "PMX_OITM_MEASUREMENTS"."SVolUnit"
 LEFT JOIN "OWGT" ON "OWGT"."UnitCode" = "PMX_OITM_MEASUREMENTS"."SWght1Unit"
 left join owhs on RDR1.WhsCode = OWHS.WhsCode
 --exclude drafts
 left join DRF1 on drf1.BaseType = '17' and drf1.BaseEntry = RDR1.DocEntry and drf1.BaseLine = RDR1.LineNum and drf1.LineStatus = 'O'
 left join ODRF on ODRF.DocEntry = DRF1.DocEntry and ODRF.DocStatus = 'O'
 INNER JOIN OCRD OCRDPDMX ON OCRDPDMX.CardCode = 'PDMX'

 WHERE "ORDR"."Confirmed" = N'Y' 
 AND "ORDR"."DocStatus" = N'O' 
 AND "RDR1"."LineStatus" = N'O' 
 AND ("OITM"."InvntItem" = N'Y' OR "OITM"."U_PMX_NIOP" = N'Y' )
 AND ( "RDR1"."OpenQty" - ISNULL( "PMX_DOLL"."LockedQuantity", 0 ) > 0 ) 
 AND NOT ( "OCRD"."validFor" = N'Y' AND ( ( "OCRD"."validFrom" IS NOT NULL AND CURRENT_TIMESTAMP < "OCRD"."validFrom" ) 
 OR ( "OCRD"."validTo" IS NOT NULL AND CURRENT_TIMESTAMP >= DATEADD( day, 1, "OCRD"."validTo" ) ) ) ) 
 AND NOT ( "OCRD"."frozenFor" = N'Y' AND ( "OCRD"."frozenFrom" IS NULL OR CURRENT_TIMESTAMP >= "OCRD"."frozenFrom" ) 
 AND ( "OCRD"."frozenTo" IS NULL OR CURRENT_TIMESTAMP < DATEADD( day, 1, "OCRD"."frozenTo" ) ) ) 
 --AND "OCRD"."U_V33_CREDITAPPV" = N'Y' 
 ---check on credithold instead of creditappv
 
and isnull(OCRD.U_CREDITHOLD,'N') = 'N'

 AND 
 (
	(rdr1.unitMsr = 'MTR' and "RDR1"."OpenQty" - ISNULL("PMX_DOLL"."LockedQuantity", 0) >= 5)
	OR
	(rdr1.unitMsr <> 'MTR')
)
 and OWHS.U_PMX_IMBP = 'Y'
  and DRF1.DocEntry is null and ODRF.DocEntry is null

 --and RDR1.ItemCode = 'TWBY96'
 --and OCRD.CardCode = 'TEST101'
 
--and rdr1.itemcode in ( '27645-44', '27645-66')

 GROUP BY "ORDR"."ObjType","ORDR"."DocEntry","ORDR"."DocNum","ORDR"."DocDueDate","RDR1"."ShipDate","ORDR"."CardCode","ORDR"."CardName",
 "ORDR"."Address2","ORDR"."ShipToCode","OSHP"."TrnspName","ORDR"."NumAtCard","RDR1"."ItemCode","RDR1"."LineNum","RDR1"."WhsCode","OITM"."ItemName","OITM"."ItmsGrpCod","ORDR"."PickRmrk",
 "RDR1"."OpenQty", PMX_DOLL."LockedQuantity", "OCRD"."U_V33_CREDITAPPV", ocrd.CreditLine,ocrd.Balance, ocrd.DNotesBal, rdr1.unitMsr,drf1.DocEntry,OCRDPDMX.U_V33_allocation,RDR1.U_NUMBOLT

order by ItemCode,"ORDR".DocEntry


DECLARE cur CURSOR LOCAL FOR 
SELECT 
ORDERs.DocEntry
,ORDERS.DocNum 
,ORDERS.LineNum 
,ORDERS.CardCode,
ORDERS.DocDueDate,
ORDERS.ItemCode,
ORDERS.OpenQuantity,
ORDERS.[Free stock],
ORDERS.UOM,
ORDERS.Allocation,
ORDERS.BoltsOrdered
from @EntitlementOrders ORDERS
order by ItemCode,DocEntry

DECLARE @DocEntry INT
DECLARE @DocNum INT
DECLARE @linenum int
DECLARE @CardCode NVARCHAR(15)
DECLARE @CurrentCardCode NVARCHAR(15)
DECLARE @DocDueDate date
DECLARE @ItemCode nvarchar(50)
DECLARE @CurrentItemCode nvarchar(50)
DECLARE @OpenQuantity NUMERIC(19,6)
DECLARE @Freestock NUMERIC(19,6)
DECLARE @CurrentFreestock NUMERIC(19,6)
DECLARE @uom nvarchar(20)
DECLARE @donotlockQty NUMERIC(19,6) -- we do not want to lock if the qty is less then 5MTR
DECLARE @firstrun int

DECLARE @Allocation int
DECLARE @CurrentAllocation int
DECLARE @NumBoltsAllocatable int

DECLARE @BoltsOrdered int



DECLARE  @OrderGroupedInfo TABLE( 
DocEntry INT, 
Linenum int,
allocationOK NVARCHAR(1), 
freestockRunning NUMERIC(19,6),
Allocation int,
NumBoltsAllocatable int
)

SET @CurrentFreestock = 0
SET @CurrentItemCode = ''
SET @donotlockQty = 0
SET @firstrun = 1
SET @NumBoltsAllocatable = 0
SET @BoltsOrdered = 1



--items to test: 4509-413 & 516703-15

	
OPEN cur
FETCH NEXT FROM cur INTO @DocEntry, @docnum,@linenum,@cardcode, @docduedate, @itemcode,@openquantity,@freestock,@uom, @Allocation,@BoltsOrdered
WHILE @@FETCH_STATUS = 0
BEGIN
	
	IF @CurrentItemCode = '' --and @CurrentFreestock = 0
	BEGIN
		---------- if uom = MTR then don't allocate the last 5mtr -> see backorder/remove partial quantity to laf.. same rule there
		If (@uom = 'MTR')
		begin
			SET @CurrentFreestock = @freestock
			SET @CurrentItemCode = @itemcode
			SET @donotlockQty = 5
			SET @CurrentAllocation = @BoltsOrdered*@Allocation
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/@CurrentAllocation)
			

		end
		else
		begin
			SET @CurrentFreestock = @freestock
			SET @CurrentItemCode = @itemcode
			SET @donotlockQty = 0
			SET @CurrentAllocation = @openquantity
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/1)

		end		

	END

	IF @CurrentItemCode = @itemcode
	BEGIN
		If (@uom = 'MTR')
		begin
			SET @CurrentAllocation = @BoltsOrdered*@Allocation
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/@CurrentAllocation)

			IF (@CurrentFreestock-@CurrentAllocation >=0)
			BEGIN
				SET @CurrentFreestock = @CurrentFreestock - @CurrentAllocation
				IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'Y', @CurrentFreestock, @CurrentAllocation,@NumBoltsAllocatable )

			END

			ELSE 
			BEGIN
			---- if the current freestock-open quantity is not >= 0 then check if the currentfreestock = 5, if so allocate 5 for mtr
				if (@NumBoltsAllocatable <1 and  @CurrentFreestock >= @donotlockQty)
				begin
					SET @CurrentFreestock = @CurrentFreestock- @CurrentAllocation
					IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'Y', @CurrentFreestock,@CurrentAllocation,@NumBoltsAllocatable )
				end
				else
				begin
					SET @CurrentFreestock = @CurrentFreestock
					IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'N', @CurrentFreestock,@CurrentAllocation,@NumBoltsAllocatable )
				end
			
			END


		end
		else
		begin
			SET @CurrentFreestock = @CurrentFreestock - @CurrentAllocation
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/1)
			IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'Y', @CurrentFreestock, @CurrentAllocation,@NumBoltsAllocatable )
			

		end
		



	END
	ELSE
	BEGIN
		--@@CurrentItemCode <> @@itemcode, switch item so reset.

		---------- if uom = MTR then don't allocate the last 5mtr -> see backorder/remove partial quantity to laf.. same rule there
		If (@uom = 'MTR')
		begin
			SET @CurrentFreestock = @freestock
			SET @CurrentItemCode = @itemcode
			SET @donotlockQty = 5
			SET @CurrentAllocation = @BoltsOrdered*@Allocation
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/@CurrentAllocation)
			
		end
		else
		begin
			SET @CurrentFreestock = @freestock
			SET @CurrentItemCode = @itemcode
			SET @donotlockQty = 0
			SET @CurrentAllocation = @openquantity
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/1)

		end		
		

		If (@uom = 'MTR')
		begin
			SET @CurrentAllocation = @BoltsOrdered*@Allocation
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/@CurrentAllocation)

			IF (@CurrentFreestock-@CurrentAllocation >=0)
			BEGIN
				SET @CurrentFreestock = @CurrentFreestock - @CurrentAllocation
				IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'Y', @CurrentFreestock, @CurrentAllocation,@NumBoltsAllocatable )

			END

			ELSE 
			BEGIN
			---- if the current freestock-open quantity is not >= 0 then check if the currentfreestock = 5, if so allocate 5 for mtr
				if (@NumBoltsAllocatable <1 and  @CurrentFreestock >= @donotlockQty)
				begin
					SET @CurrentFreestock = @CurrentFreestock- @CurrentAllocation
					IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'Y', @CurrentFreestock,@CurrentAllocation,@NumBoltsAllocatable )
				end
				else
				begin
					SET @CurrentFreestock = @CurrentFreestock
					IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'N', @CurrentFreestock,@CurrentAllocation,@NumBoltsAllocatable )
				end
			
			END


		end
		else
		begin

			SET @CurrentFreestock = @CurrentFreestock - @CurrentAllocation
			SET @NumBoltsAllocatable = floor(@CurrentFreestock/1)
			IF NOT @DocEntry IS NULL   INSERT INTO @OrderGroupedInfo VALUES ( @DocEntry,@linenum, 'Y', @CurrentFreestock, @CurrentAllocation,@NumBoltsAllocatable )


		end
		
	END
	
   
   
   FETCH NEXT FROM cur INTO @DocEntry, @docnum,@linenum,@cardcode, @docduedate, @itemcode,@openquantity,@freestock,@uom,@Allocation,@BoltsOrdered
END

CLOSE cur
DEALLOCATE cur


INSERT @tbl
 SELECT
 orders.* 
 ,info.allocationOK
 ,info.freestockRunning
 ,info.Allocation
 ,info.NumBoltsAllocatable

 
 
FROM @EntitlementOrders orders
left join @OrderGroupedInfo info on info.DocEntry = orders.DocEntry and info.Linenum = orders.LineNum
 

   RETURN
END



GO

